Module Module1

    Sub Main()

        Dim locBoolean As Boolean
        locBoolean = True 'Expression is true.
        locBoolean = False 'Expression is false.

        'Numeric conversions:
        Dim locInt As Integer = CInt(locBoolean) ' locInt is -1
        locInt = Convert.ToInt32(locBoolean) ' locInt is now +1!!!
        Dim locLong As Long = CLng(locBoolean) ' locLong is -1
        locLong = Convert.ToInt64(locBoolean) ' locLong is +1

        locBoolean = CBool(-1) ' locBoolean is True.
        locBoolean = CBool(0) ' locBoolean is False.
        locBoolean = CBool(1) ' locBoolean is True.
        locBoolean = Convert.ToBoolean(-1) ' locBoolean is True.
        locBoolean = Convert.ToBoolean(+1) ' locBoolean is True.
        locBoolean = CBool(100) ' locBoolean is True.
        locBoolean = Convert.ToBoolean(100) ' locBoolean is True.

        'String Conversions helps:
        Console.WriteLine(System.Boolean.FalseString)
        Console.WriteLine(System.Boolean.TrueString)

        'Vergleichsoperatoren
        Dim locString1 As String = "Uwe"
        Dim locString2 As String = "Klaus"
        locBoolean = (locString1 = locString2) ' Returns False.
        locBoolean = (locString1 > locString2) ' Returns True.
        locBoolean = (locString1 < locString2) ' Returns False.
        locBoolean = (locString1 >= locString2) ' Returns True.
        locBoolean = (locString1 <= locString2) ' Returns False.
        locBoolean = (locString1 <> locString2) ' Returns True.
        locBoolean = (locString1 Is locString2) ' Returns False.
        locString2 = "Uwe"

        String.Intern(locString2) ' Now returns True, because both
        locBoolean = (locString1 Is locString2) ' String objects point to a range. (see chapter 7)
        locString1 = "Santa Claus, you think he's in town already?"
        locString2 = "Santa Klaus*"
        locBoolean = (locString1 Like locString2) ' Returns True.

        locString1 = "Miriam"

        Select Case locString1

            Case "Miriam"
                Console.WriteLine("Hit!")

            Case Is > "N"
                Console.WriteLine("Name comes after 'M' in the alphabet")

            Case Is < "M"
                Console.WriteLine("Name comes before 'M' in the alphabet")

            Case Else
                Console.WriteLine("Name starts with 'M'")

                'Case Like "Miri"
                'This doesn't work!!!
        End Select
    End Sub

End Module
