﻿'This is the old version, which we will replace 
'by the "property-version".
'
'Public Class Contact
'    Public FirstName As String
'    Public LastName As String
'    Public ZIP As String
'    Public City As String
'End Class

Public Class Contact

    Private myFirstName As String
    Private myLastName As String
    Private myZIP As String
    Private myCity As String

    Private myDateCreated As Date = Date.Now

    'Default constructor (without arguments).
    Sub New()
        myDateCreated = Date.Now
    End Sub

    'This constructor takes several arguments to initialize the instance.
    Sub New(ByVal firstName As String, ByVal lastName As String, _
            ByVal zip As String, ByVal city As String)

        'It calles - and this ONLY works as the first code line 
        'after the signature definition - the class' base constructor.
        Me.New()

        'Initialize backing fields with passed arguments.
        myFirstName = firstName
        myLastName = lastName
        zip = zip
        myCity = city
    End Sub

    Public ReadOnly Property DateCreated() As Date
        Get
            Return myDateCreated
        End Get
    End Property

    Property LastName() As String
        Get
            Return myLastName
        End Get

        Set(ByVal value As String)
            value = value.TrimEnd
            If value.Length > 20 Then
                myLastName = value.Substring(0, 20)
            Else
                myLastName = value
            End If
        End Set
    End Property

    Property FirstName() As String
        Get
            Return myFirstName
        End Get
        Set(ByVal value As String)
            myFirstName = value
        End Set
    End Property

    Property ZIP() As String
        Get
            Return myZIP
        End Get
        Set(ByVal value As String)
            myZIP = value
        End Set
    End Property

    Property City() As String
        Get
            Return myCity
        End Get
        Set(ByVal value As String)
            myCity = value
        End Set
    End Property

    Public Function ContactText() As String

        Return Me.LastName & ", " & Me.FirstName & ", " & _
                Me.ZIP & ", " & Me.City

    End Function

    Private Function EllipseString(ByVal text As String, ByVal MaxLength As Integer) As String

        Dim tmpText As String

        If text.Length > MaxLength Then
            tmpText = text.Substring(0, MaxLength - 3) + "..."
        Else
            tmpText = text
        End If
        Return tmpText
    End Function

End Class