Module LinkedList

    Sub Main()
        Dim locLinkedList As New LinkedList(Of Address)
        Dim locAdressen As ArrayList = Address.RandomAddresses(50)
        Dim locAdresse As Address = Nothing

        'Add 8 addresses to the end of each corresponding LinkedList.
        For c As Integer = 0 To 49

            'the 25th we're remember for later search in the list.
            If c = 25 Then
                locAdresse = DirectCast(locAdressen(c), Address)
            End If
            locLinkedList.AddLast(DirectCast(locAdressen(c), Address))
        Next

        Dim locLinkedListNode As LinkedListNode(Of Address)

        'Find the node which represents the 25th item in the list we remembered.
        locLinkedListNode = locLinkedList.Find(locAdresse)
        Console.WriteLine("Before " & locLinkedListNode.Value.ToString & " comes " & _
                          locLinkedListNode.Previous.Value.ToString & _
                          " and is followed by " & locLinkedListNode.Next.Value.ToString)
        Console.WriteLine()

        'Insert a new address object before the 25th item:
        Console.WriteLine("Insert Adriana Ardelean before!")
        locLinkedList.AddBefore(locLinkedListNode, _
                New Address("SweetyMatch", "Ardelean", "Adriana", "99999", "Bremen"))

        Console.WriteLine()

        'Print out the same again, but this time it should reflext the changes.
        Console.WriteLine("Before " & locLinkedListNode.Value.ToString & " comes " & _
                          locLinkedListNode.Previous.Value.ToString & _
                          " and is followed by " & locLinkedListNode.Next.Value.ToString)
        Console.WriteLine()
        Console.WriteLine("Press any key to quit.")
        Console.ReadKey()
    End Sub

End Module
