﻿Module Module1

    Sub Main()

        'Instantiating with New and thus
        'creating memory for the Contact
        'object on the Managed Heap.
        'Simultaneously initialize the instance with data.
        Dim objVarContact As New Contact With {.LastName = "Doe", _
                    .FirstName = "Joe", .ZIP = "93111", .City = "Los Angeles"}

        'Only create object variable,
        'but don't reserve memory space!
        Dim objVarContact2 As Contact

        'objVarContact2 now points to the
        'same instance as objVarContact
        objVarContact2 = objVarContact

        'It can be proven:
        'Changing of the instance happens...
        objVarContact2.LastName = "Smith"

        'via both object variables which
        'of course reflect the same.
        Console.WriteLine(objVarContact.LastName)

        Console.WriteLine()
        Console.WriteLine("Press button to exit")
        Console.ReadKey()
    End Sub

    Sub ProcessClass()
        '.
        '.
        '.
        Dim tmpContact As New Contact
        tmpContact.City = Console.ReadLine

    End Sub
End Module

Public Class Contact
    Public FirstName As String
    Public LastName As String
    Public ZIP As String
    Public City As String
End Class

