﻿Imports System.Threading.Tasks

Public Class frmSingleThreading

    Private Sub btnStartCounting_Click(ByVal sender As System.Object,
                                       ByVal e As System.EventArgs) Handles btnStartCounting.Click

        'Delete list if it already contains items:
        PrimesListBox.Items.Clear()

        Dim sw = Stopwatch.StartNew

        Dim PrimesFound = 0
        Dim StartNumber = Integer.Parse(LastPrimeBeforeTextBox.Text)
        Dim leadingZeros = StartNumber.ToString.Length

        For numberToTest = StartNumber To 2 Step -1
            Dim isPrime = True
            InfoLabel.Text = "Testing: " & numberToTest.ToString("#,##0")
            InfoLabel.Refresh()

            For valueToTest = 2 To numberToTest - 1

                If (numberToTest / valueToTest) = (numberToTest \ valueToTest) Then
                    isPrime = False
                    Exit For
                End If

            Next

            If isPrime Then
                'Little trick (pathetic but easier):
                'for the ListBox content to be sorted numerically we insert leading zeroes.
                PrimesListBox.Items.Add(numberToTest.ToString(New String("0"c, leadingZeros)))

                PrimesListBox.Refresh()
                PrimesFound += 1

                If PrimesFound = PrimesToFindUpDown.Value Then
                    Exit For
                End If

            End If
        Next

        sw.Stop()
        InfoLabel.Text = "Duration in milliseconds: " & sw.ElapsedMilliseconds.ToString("#,##0")
    End Sub
End Class
